import { Sequelize, DataTypes, Model, Optional } from 'sequelize';
import { Account, Category, Transaction, User } from './controller/models';
import { Router } from './controller/router';

import path from 'path';
import { fileURLToPath } from 'url';
import { Storage } from './controller/storage';
import { MonthlyReport } from './controller/models/MonthlyReport';


Storage.__dirname = __dirname



let init = async () => {
    // Initialize Sequelize instance and define database connection
    const sequelize = new Sequelize('sqlite::memory:', {
        host: 'localhost',
        dialect: 'sqlite', // Change this to your database dialect
        // Other options...
    });


    User.initialize(sequelize);

    Category.initialize(sequelize);

    Transaction.initialize(sequelize);


    Account.initialize(sequelize);

    MonthlyReport.initialize(sequelize);
    // Set up associations between models
    User.associate({ Transaction, Category });
    Category.associate({ User, Transaction });
    Transaction.associate({ User, Category, Account, MonthlyReport });
    Account.associate({Transaction})

    MonthlyReport.associate({ Transaction, Account });

    await sequelize.sync({ force: true });

    await User.create({
        Name: "Max Mustermann",
        Email: "test@test.de",
        Password: "sdfsf"
    })
    await Category.create({
        Name: "Allgemein",
        Description: null
    })
    await Category.create({
        Name:"Games",
        Description:"Games"
    })
    await Account.create({
        Name:"None"
    })
    await Account.create({
        Name:"Bar"
    })
    await Account.create({
        Name:"Konto1"
    })

    let z = await Transaction.create({
        Amount:50.0,
        Date:new Date(),
        Type:"expense",
        //@ts-ignore
        UserID: 1, // Associate the transaction with the user
        //@ts-ignore
        CategoryID: 1,
    })


    await Transaction.create({
        Amount:10.0,
        Date:new Date(),
        Type:"expense",
        //@ts-ignore
        UserID: 1, // Associate the transaction with the user
        //@ts-ignore
        CategoryID: 1,
    })
    await Transaction.create({
        Amount:60.0,
        Date:new Date(),
        Type:"income",
        //@ts-ignore
        UserID: 1, // Associate the transaction with the user
        //@ts-ignore
        CategoryID: 1,
    })
    await Transaction.create({
        Amount:60.0,
        Date:new Date(),
        Type:"income",
        //@ts-ignore
        UserID: 1, // Associate the transaction with the user
        //@ts-ignore
        CategoryID: 2,
    })

    //await Transaction.transferAmountFromTo(1,1,2,50);


    let x = await Transaction.getTotalAmountForUser(1)
    await Transaction.transferAmountFromTo(1,1,2,50);
    console.log(x)

    new Router(path.join(__dirname,'../public'));

    console.log(path.join(__dirname,'../public'))

    MonthlyReport.generateMonthlyReport(12,2023,2)
}

init();